Save This Page
Home » spring-webflow-2.0.3.RELEASE » org.springframework.webflow » action » [javadoc | source]
org.springframework.webflow.action
public class: FormAction [javadoc | source]
java.lang.Object
   org.springframework.webflow.action.AbstractAction
      org.springframework.webflow.action.MultiAction
         org.springframework.webflow.action.FormAction

All Implemented Interfaces:
    org.springframework.beans.factory.InitializingBean, Action, org.springframework.beans.factory.InitializingBean

Multi-action that implements common logic dealing with input forms. This class uses the Spring Web data binding code to do binding and validation.

Several action execution methods are provided:

Since this is a multi-action a subclass could add any number of additional action execution methods, e.g. "setupReferenceData(RequestContext)", or "processSubmit(RequestContext)".

Using this action, it becomes very easy to implement form preparation and submission logic in your flow. One way to do this follows:

  1. Create a view state to display the form. In a render action of that state, invoke setupForm to prepare the new form for display.
  2. On a matching "submit" transition execute an action that invokes bindAndValidate to bind incoming request parameters to the form object and validate the form object.
  3. If there are binding or validation errors, the transition will not be allowed and the view state will automatically be re-entered.
  4. If binding and validation are successful go to an action state called "processSubmit" (or any other appropriate name). This will invoke an action method called "processSubmit" you must provide on a subclass to process form submission, e.g. interacting with the business logic.
  5. If business processing is ok, continue to a view state to display the success view.

Here is an example implementation of such a form flow:

<view-state id="displayCriteria">
<on-render>
<evaluate expression="formAction.setupForm"/>
</on-render>
<transition on="search" to="executeSearch">
<evaluate expression="formAction.bindAndValidate"/>
</transition>
</view-state>

When you need additional flexibility consider splitting the view state above acting as a single logical form state into multiple states. For example, you could have one action state handle form setup, a view state trigger form display, another action state handle data binding and validation, and another process form submission. This would be a bit more verbose but would also give you more control over how you respond to specific results of fine-grained actions that occur within the flow.

Subclassing hooks:

Note that this action does not provide a referenceData() hook method similar to that of Spring MVC's SimpleFormController. If you wish to expose reference data to populate form drop downs you can define a custom action method in your FormAction subclass that does just that. Simply invoke it as either a chained action as part of the setupForm state, or as a fine grained state definition itself.

For example, you might create this method in your subclass:

public Event setupReferenceData(RequestContext context) throws Exception {
MutableAttributeMap requestScope = context.getRequestScope();
requestScope.put("refData", lookupService.getSupportingFormData());
return success();
}
... and then invoke it like this:
<view-state id="displayCriteria">
<on-render>
<evaluate expression="formAction.setupForm"/>
<evaluate expression="formAction.setupReferenceData"/>
</on-render>
...
</view-state>
This style of calling multiple action methods in a chain (Chain of Responsibility) is preferred to overriding a single action method. In general, action method overriding is discouraged.

When it comes to validating submitted input data using a registered org.springframework.validation.Validator , this class offers the following options:

FormAction configurable properties
name default description
formObjectName formObject The name of the form object. The form object will be set in the configured scope using this name.
formObjectClass null The form object class for this action. An instance of this class will get populated and validated. Required when using a validator.
formObjectScope flow The scope in which the form object will be put. If put in flow scope the object will be cached and reused over the life of the flow, preserving previous values. Request scope will cause a new fresh form object instance to be created on each request into the flow execution.
formErrorsScope flash The scope in which the form object errors instance will be put. If put in flash scope form errors will be cached until the next user event is signaled.
propertyEditorRegistrar null The strategy used to register custom property editors with the data binder. This is an alternative to overriding the #registerPropertyEditors(PropertyEditorRegistry) hook method.
validator null The validator for this action. The validator must support the specified form object class.
messageCodesResolver null Set the strategy to use for resolving errors into message codes.

Field Summary
public static final  String DEFAULT_FORM_OBJECT_NAME    The default form object name ("formObject"). 
public static final  String VALIDATOR_METHOD_ATTRIBUTE    Optional attribute that identifies the method that should be invoked on the configured validator instance, to support piecemeal wizard page validation ("validatorMethod"). 
Fields inherited from org.springframework.webflow.action.AbstractAction:
logger
Constructor:
 public FormAction() 
 public FormAction(Class formObjectClass) 
    Creates a new form action that manages instance(s) of the specified form object class.
    Parameters:
    formObjectClass - the class of the form object (must be instantiable)
Method from org.springframework.webflow.action.FormAction Summary:
bind,   bindAndValidate,   createBinder,   createFormObject,   doBind,   doValidate,   getFormErrors,   getFormErrorsScope,   getFormObject,   getFormObjectAccessor,   getFormObjectClass,   getFormObjectName,   getFormObjectScope,   getMessageCodesResolver,   getPropertyEditorRegistrar,   getValidateMethodInvoker,   getValidator,   initAction,   initBinder,   registerPropertyEditors,   registerPropertyEditors,   resetForm,   setFormErrorsScope,   setFormObjectClass,   setFormObjectName,   setFormObjectScope,   setMessageCodesResolver,   setPropertyEditorRegistrar,   setValidator,   setupForm,   toString,   validate,   validationEnabled
Methods from org.springframework.webflow.action.MultiAction:
doExecute,   getMethodResolver,   setMethodResolver,   setTarget
Methods from org.springframework.webflow.action.AbstractAction:
afterPropertiesSet,   doExecute,   doPostExecute,   doPreExecute,   error,   error,   execute,   getActionNameForLogging,   getEventFactorySupport,   initAction,   no,   result,   result,   result,   result,   success,   success,   yes
Methods from java.lang.Object:
equals,   getClass,   hashCode,   notify,   notifyAll,   toString,   wait,   wait,   wait
Method from org.springframework.webflow.action.FormAction Detail:
 public Event bind(RequestContext context) throws Exception 
    Bind incoming request parameters to allowed fields of the form object.

    NOTE: This action method is not designed to be overridden and might become final in a future version of Spring Web Flow. If you need to execute custom data binding logic have your flow call this method along with your own custom methods as part of a single action chain. Alternatively, override the #doBind(RequestContext, DataBinder) hook.

 public Event bindAndValidate(RequestContext context) throws Exception 
    Bind incoming request parameters to allowed fields of the form object and then validate the bound form object if a validator is configured.

    NOTE: This action method is not designed to be overridden and might become final in a future version of Spring Web Flow. If you need to execute custom bind and validate logic have your flow call this method along with your own custom methods as part of a single action chain. Alternatively, override the #doBind(RequestContext, DataBinder) or #doValidate(RequestContext, Object, Errors) hooks.

 protected DataBinder createBinder(RequestContext context,
    Object formObject) throws Exception 
 protected Object createFormObject(RequestContext context) throws Exception 
    Create the backing form object instance that should be managed by this form action . By default, will attempt to instantiate a new form object instance of type #getFormObjectClass() transiently in memory.

    Subclasses should override if they need to load the form object from a specific location or resource such as a database or filesystem.

    Subclasses should override if they need to customize how a transient form object is assembled during creation.

 protected  void doBind(RequestContext context,
    DataBinder binder) throws Exception 
    Bind allowed parameters in the external context request parameter map to the form object using given binder.
 protected  void doValidate(RequestContext context,
    Object formObject,
    Errors errors) throws Exception 
    Validate given form object using a registered validator. If a "validatorMethod" action property is specified for the currently executing action, the identified validator method will be invoked. When no such property is found, the defualt validate() method is invoked.
 protected Errors getFormErrors(RequestContext context) throws Exception 
    Convenience method that returns the form object errors for this form action. If not found in the configured scope, a new form object errors will be created, initialized, and exposed in the confgured scope .

    Keep in mind that an Errors instance wraps a form object, so a form object will also be created if required (see #getFormObject(RequestContext) ).

 public ScopeType getFormErrorsScope() 
    Get the scope in which the Errors object will be placed.
 protected Object getFormObject(RequestContext context) throws Exception 
    Convenience method that returns the form object for this form action. If not found in the configured scope, a new form object will be created by a call to #createFormObject(RequestContext) and exposed in the configured scope .

    The returned form object will become the current form object.

 protected FormObjectAccessor getFormObjectAccessor(RequestContext context) 
    Factory method that returns a new form object accessor for accessing form objects in the provided request context.
 public Class getFormObjectClass() 
    Return the form object class for this action.
 public String getFormObjectName() 
    Return the name of the form object in the configured scope.
 public ScopeType getFormObjectScope() 
    Get the scope in which the form object will be placed.
 public MessageCodesResolver getMessageCodesResolver() 
    Return the strategy to use for resolving errors into message codes.
 public PropertyEditorRegistrar getPropertyEditorRegistrar() 
    Get the property editor registration strategy for this action's data binders.
 protected DispatchMethodInvoker getValidateMethodInvoker() 
    Returns a dispatcher to invoke validation methods. Subclasses could override this to return a custom dispatcher.
 public Validator getValidator() 
    Returns the validator for this action.
 protected  void initAction() 
 protected  void initBinder(RequestContext context,
    DataBinder binder) 
 protected  void registerPropertyEditors(PropertyEditorRegistry registry) 
    Register custom editors to perform type conversion on fields of your form object during data binding and form display. This method is called on form errors initialization and data binder initialization.

    Property editors give you full control over how objects are transformed to and from a formatted String form for display on a user interface such as a HTML page.

    This default implementation will simply call registerCustomEditors on the propertyEditorRegistrar object that has been set for the action, if any.

 protected  void registerPropertyEditors(RequestContext context,
    PropertyEditorRegistry registry) 
    Register custom editors to perform type conversion on fields of your form object during data binding and form display. This method is called on form errors initialization and data binder initialization.

    Property editors give you full control over how objects are transformed to and from a formatted String form for display on a user interface such as a HTML page.

    This default implementation will call the simpler form of the method not taking a RequestContext parameter.

 public Event resetForm(RequestContext context) throws Exception 
    Resets the form by clearing out the form object in the specified scope and recreating it.

    NOTE: This action method is not designed to be overridden and might become final in a future version of Spring Web Flow. If you need to execute custom reset logic have your flow call this method along with your own custom methods as part of a single action chain.

 public  void setFormErrorsScope(ScopeType errorsScope) 
    Set the scope in which the Errors object will be placed. The default if not set is flash scope .
 public  void setFormObjectClass(Class formObjectClass) 
    Set the form object class for this action. An instance of this class will get populated and validated. This is a required property if you register a validator with the form action (#setValidator(Validator) )!

    If no form object name is set at the moment this method is called, a form object name will be automatically generated based on the provided form object class using ClassUtils#getShortNameAsProperty(java.lang.Class) .

 public  void setFormObjectName(String formObjectName) 
    Set the name of the form object in the configured scope. The form object will be included in the configured scope under this name.
 public  void setFormObjectScope(ScopeType scopeType) 
    Set the scope in which the form object will be placed. The default if not set is flow scope .
 public  void setMessageCodesResolver(MessageCodesResolver messageCodesResolver) 
    Set the strategy to use for resolving errors into message codes. Applies the given strategy to all data binders used by this action.

    Default is null, i.e. using the default strategy of the data binder.

 public  void setPropertyEditorRegistrar(PropertyEditorRegistrar propertyEditorRegistrar) 
 public  void setValidator(Validator validator) 
    Set the validator for this action. When setting a validator, you must also set the form object class . The validator must support the specified form object class.
 public Event setupForm(RequestContext context) throws Exception 
    Prepares a form object for display in a new form, creating it and caching it in the #getFormObjectScope() if necessary. Also installs custom property editors for formatting form object values in UI controls such as text fields.

    A new form object instance will only be created (or more generally acquired) with a call to #createFormObject(RequestContext) , if the form object does not yet exist in the configured scope . If you want to reset the form handling machinery, including creation or loading of a fresh form object instance, call #resetForm(RequestContext) instead.

    NOTE: This action method is not designed to be overridden and might become final in a future version of Spring Web Flow. If you need to execute custom form setup logic have your flow call this method along with your own custom methods as part of a single action chain.

 public String toString() 
 public Event validate(RequestContext context) throws Exception 
    Validate the form object by invoking the validator if configured.

    NOTE: This action method is not designed to be overridden and might become final in a future version of Spring Web Flow. If you need to execute custom validation logic have your flow call this method along with your own custom methods as part of a single action chain. Alternatively, override the #doValidate(RequestContext, Object, Errors) hook.

 protected boolean validationEnabled(RequestContext context) 
    Return whether validation should be performed given the state of the flow request context. Default implementation always returns true.